# vehicle_func.h File Reference

Functions related to vehicles. More...

`#include "gfx_type.h"`
`#include "direction_type.h"`
`#include "command_type.h"`
`#include "vehicle_type.h"`
`#include "engine_type.h"`
`#include "transport_type.h"`
`#include "newgrf_config.h"`
`#include "company_type.h"`

Go to the source code of this file.

## Data Structures
struct | GetNewVehiclePosResult
| Position information of a vehicle after it moved. More...
## Defines
#define | is_custom_sprite(x) (x >= 0xFD)
#define | IS_CUSTOM_FIRSTHEAD_SPRITE(x) (x == 0xFD)
#define | IS_CUSTOM_SECONDHEAD_SPRITE(x) (x == 0xFE)
## Typedefs
typedef Vehicle * | VehicleFromPosProc (Vehicle *v, void *data)
## Functions
void | VehicleServiceInDepot (Vehicle *v)
uint | CountVehiclesInChain (const Vehicle *v)
void | CountCompanyVehicles (CompanyID cid, uint counts[4])
| Count the number of vehicles of a company.
void | FindVehicleOnPos (TileIndex tile, void *data, VehicleFromPosProc *proc)
| Find a vehicle from a specific location.
void | FindVehicleOnPosXY (int x, int y, void *data, VehicleFromPosProc *proc)
| Find a vehicle from a specific location.
bool | HasVehicleOnPos (TileIndex tile, void *data, VehicleFromPosProc *proc)
| Checks whether a vehicle in on a specific location.
bool | HasVehicleOnPosXY (int x, int y, void *data, VehicleFromPosProc *proc)
| Checks whether a vehicle in on a specific location.
void | CallVehicleTicks ()
uint8 | CalcPercentVehicleFilled (const Vehicle *v, StringID *colour)
| Calculates how full a vehicle is.
byte | VehicleRandomBits ()
| Get a value for a vehicle's random_bits.
void | ResetVehiclePosHash ()
void | ResetVehicleColourMap ()
byte | GetBestFittingSubType (Vehicle *v_from, Vehicle *v_for)
| Get the best fitting subtype when 'cloning'/'replacing' v_from with v_for.
CommandCost | RefitVehicle (Vehicle *v, bool only_this, CargoID new_cid, byte new_subtype, DoCommandFlag flags)
| Refits a vehicle (chain).
void | ViewportAddVehicles (DrawPixelInfo *dpi)
void | ShowNewGrfVehicleError (EngineID engine, StringID part1, StringID part2, GRFBugs bug_type, bool critical)
| Displays a "NewGrf Bug" error message for a engine, and pauses the game if not networking.
bool | HasVehicleOnTunnelBridge (TileIndex tile, TileIndex endtile, const Vehicle *ignore=NULL)
| Finds vehicle in tunnel / bridge.
void | DecreaseVehicleValue (Vehicle *v)
void | CheckVehicleBreakdown (Vehicle *v)
void | AgeVehicle (Vehicle *v)
void | VehicleEnteredDepotThisTick (Vehicle *v)
| Adds a vehicle to the list of vehicles, that visited a depot this tick.
void | VehicleMove (Vehicle *v, bool update_viewport)
| Move a vehicle in the game state; that is moving it's position in the position hashes and marking it's location in the viewport dirty if requested.
void | MarkSingleVehicleDirty (const Vehicle *v)
| Marks viewports dirty where the vehicle's image is In fact, it equals BeginVehicleMove(v); EndVehicleMove(v);.
UnitID | GetFreeUnitNumber (VehicleType type)
| Get an unused unit number for a vehicle (if allowed).
CommandCost | SendAllVehiclesToDepot (VehicleType type, DoCommandFlag flags, bool service, Owner owner, uint16 vlw_flag, uint32 id)
| Send all vehicles of type to depots.
void | VehicleEnterDepot (Vehicle *v)
bool | CanBuildVehicleInfrastructure (VehicleType type)
| Check whether we can build infrastructure for the given vehicle type.
GetNewVehiclePosResult | GetNewVehiclePos (const Vehicle *v)
| Get position information of a vehicle when moving one pixel in the direction it is facing.
Direction | GetDirectionTowards (const Vehicle *v, int x, int y)
static bool | IsCompanyBuildableVehicleType (VehicleType type)
static bool | IsCompanyBuildableVehicleType (const BaseVehicle *v)
struct Livery * | GetEngineLivery (EngineID engine_type, CompanyID company, EngineID parent_engine_type, const Vehicle *v, byte livery_setting)
| Determines the livery for a vehicle.
SpriteID | GetEnginePalette (EngineID engine_type, CompanyID company)
| Get the colour map for an engine.
SpriteID | GetVehiclePalette (const Vehicle *v)
| Get the colour map for a vehicle.
uint | GetVehicleCapacity (const Vehicle *v, uint16 *mail_capacity=NULL)
| Determines capacity of a given vehicle from scratch.
static uint32 | GetCmdBuildVeh (VehicleType type)
static uint32 | GetCmdBuildVeh (const BaseVehicle *v)
static uint32 | GetCmdSellVeh (VehicleType type)
static uint32 | GetCmdSellVeh (const BaseVehicle *v)
static uint32 | GetCmdRefitVeh (VehicleType type)
static uint32 | GetCmdRefitVeh (const BaseVehicle *v)
static uint32 | GetCmdSendToDepot (VehicleType type)
static uint32 | GetCmdSendToDepot (const BaseVehicle *v)
bool | EnsureNoVehicleOnGround (TileIndex tile)
void | StopAllVehicles ()
bool | CanVehicleUseStation (EngineID engine_type, const struct Station *st)
bool | CanVehicleUseStation (const Vehicle *v, const struct Station *st)
void | ReleaseDisastersTargetingVehicle (VehicleID vehicle)
| Notify disasters that we are about to delete a vehicle.
## Variables
const uint32 | _veh_build_proc_table []
const uint32 | _veh_sell_proc_table []
const uint32 | _veh_refit_proc_table []
const uint32 | _send_to_depot_proc_table []
VehicleID | _vehicle_id_ctr_day
const Vehicle * | _place_clicked_vehicle
VehicleID | _new_vehicle_id
uint16 | _returned_refit_capacity
byte | _age_cargo_skip_counter
| Skip aging of cargo?

## Detailed Description

Functions related to vehicles.

Definition in file vehicle_func.h.

## Function Documentation

uint8 CalcPercentVehicleFilled | ( | const Vehicle * | v,
|  | StringID * | colour |
| ) |  |  |

Calculates how full a vehicle is.

Parameters:

  | v | The Vehicle to check. For trains, use the first engine.
  | colour | The string to show depending on if we are unloading or loading

Returns:
  A percentage of how full the Vehicle is.

Definition at line 965 of file vehicle.cpp.

References Vehicle::cargo, Vehicle::cargo_cap, Vehicle::cargo_type, CargoList< Tinst >::Count(), Vehicle::current_order, SpecializedStation< Station, false >::GetIfValid(), Order::GetLoadType(), Station::goods, HasBit(), max(), Vehicle::Next(), OLFB_NO_LOAD, and Vehicle::vehicle_flags.

Referenced by LoadUnloadVehicle(), and ProcessConditionalOrder().

bool CanBuildVehicleInfrastructure | ( | VehicleType | type | ) |

Check whether we can build infrastructure for the given vehicle type.

This to disable building stations etc. when you are not allowed/able to have the vehicle type yet.

Parameters:

  | type | the vehicle type to check this for

Returns:
  true if there is any reason why you may build the infrastructure for the given vehicle type

Definition at line 1295 of file vehicle.cpp.

References _settings_client, _settings_game, GUISettings::always_build_infrastructure, ClientSettings::gui, HasBit(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), max(), VehicleSettings::max_aircraft, VehicleSettings::max_roadveh, VehicleSettings::max_ships, VehicleSettings::max_trains, BaseVehicle::type, VEH_AIRCRAFT, VEH_ROAD, VEH_SHIP, VEH_TRAIN, and GameSettings::vehicle.

Referenced by MainToolbarWindow::OnKeyPress(), MainToolbarWindow::OnPaint(), and BuildDocksToolbarWindow::OnPaint().

void CountCompanyVehicles | ( | CompanyID | cid,
|  | uint | counts[4] |
| ) |  |  |

Count the number of vehicles of a company.

Parameters:

  | c | Company owning the vehicles.
  `[out]` | counts | Array of counts. Contains the vehicle count ordered by type afterwards.

Definition at line 539 of file vehicle.cpp.

References Vehicle::IsPrimaryVehicle(), and BaseVehicle::type.

Referenced by CompanyWindow::DrawWidget(), GetFreeUnitNumber(), and MayCompanyTakeOver().

void FindVehicleOnPos | ( | TileIndex | tile,
|  | void * | data,
|  | VehicleFromPosProc * | proc |
| ) |  |  |

Find a vehicle from a specific location.

It will call proc for ALL vehicles on the tile and YOU must make SURE that the "best one" is stored in the data value and is ALWAYS the same regardless of the order of the vehicles where proc was called on! When you fail to do this properly you create an almost untraceable DESYNC!

Note:
  The return value of proc will be ignored.
  Use this when you have the intention that all vehicles should be iterated over.

Parameters:

  | tile | The location on the map
  | data | Arbitrary data passed to proc
  | proc | The proc that determines whether a vehicle will be "found".

Definition at line 411 of file vehicle.cpp.

References VehicleFromPos().

Referenced by CheckTrainCollision(), CmdConvertRail(), DeleteLastWagon(), FloodVehicles(), FollowTrainReservation(), GetTrainForReservation(), RoadStop::Entry::Rebuild(), and RemoveRoadStop().

void FindVehicleOnPosXY | ( | int | x,
|  | int | y,
|  | void * | data,
|  | VehicleFromPosProc * | proc |
| ) |  |  |

Find a vehicle from a specific location.

It will call proc for ALL vehicles on the tile and YOU must make SURE that the "best one" is stored in the data value and is ALWAYS the same regardless of the order of the vehicles where proc was called on! When you fail to do this properly you create an almost untraceable DESYNC!

Note:
  The return value of proc will be ignored.
  Use this when you have the intention that all vehicles should be iterated over.

Parameters:

  | x | The X location on the map
  | y | The Y location on the map
  | data | Arbitrary data passed to proc
  | proc | The proc that determines whether a vehicle will be "found".

Definition at line 351 of file vehicle.cpp.

References VehicleFromPosXY().

Referenced by CheckTrainCollision().

byte GetBestFittingSubType | ( | Vehicle * | v_from,
|  | Vehicle * | v_for |
| ) |  |  |

Get the best fitting subtype when 'cloning'/'replacing' v_from with v_for.

Assuming they are going to carry the same cargo ofcourse!

Parameters:

  | v_from | the vehicle to match the subtype from
  | v_for | the vehicle to get the subtype for

Returns:
  the best sub type

Definition at line 170 of file vehicle_gui.cpp.

References CALLBACK_FAILED, EngineInfo::callback_mask, Engine::CanCarryCargo(), Vehicle::cargo_subtype, Vehicle::cargo_type, CBID_VEHICLE_CARGO_SUFFIX, CBM_VEHICLE_CARGO_SUFFIX, Vehicle::First(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_engine_pool >::Get(), GetCargoSubtypeText(), GetVehicleCallback(), HasBit(), and Vehicle::InvalidateNewGRFCache().

Referenced by BuildReplacementVehicle(), and CmdCloneVehicle().

struct Livery* GetEngineLivery | ( | EngineID | engine_type,
|  | CompanyID | company,
|  | EngineID | parent_engine_type,
|  | const Vehicle * | v,
|  | byte | livery_setting |
| ) |  |  | `[read]`

Determines the livery for a vehicle.

Parameters:

  | engine_type | EngineID of the vehicle
  | company | Owner of the vehicle
  | parent_engine_type | EngineID of the front vehicle. INVALID_VEHICLE if vehicle is at front itself.
  | v | the vehicle. NULL if in purchase list etc.
  | livery_setting | The livery settings to use for acquiring the livery information.

Returns:
  livery to use

Definition at line 1340 of file vehicle.cpp.

References AIR_CTOL, Vehicle::cargo_type, CC_PASSENGERS, CT_INVALID, EF_RAIL_IS_MU, EF_ROAD_TRAM, RailVehicleInfo::engclass, Vehicle::First(), SpecializedVehicle< Train, VEH_TRAIN >::From(), CargoSpec::Get(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_engine_pool >::Get(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_company_pool >::Get(), Engine::GetDefaultCargoType(), HasBit(), Livery::in_use, IsCargoInClass(), LIT_ALL, LIT_COMPANY, RAILVEH_WAGON, Engine::type, UsesWagonOverride(), VEH_AIRCRAFT, VEH_ROAD, VEH_SHIP, and VEH_TRAIN.

SpriteID GetEnginePalette | ( | EngineID | engine_type,
|  | CompanyID | company |
| ) |  |  |

Get the colour map for an engine.

This used for unbuilt engines in the user interface.

Parameters:

  | engine_type | ID of engine
  | company | ID of company

Returns:
  A ready-to-use palette modifier

Definition at line 1485 of file vehicle.cpp.

Referenced by DrawEngineList(), NewsWindow::DrawWidget(), and EnginePreviewWindow::DrawWidget().

UnitID GetFreeUnitNumber | ( | VehicleType | type | ) |

Get an unused unit number for a vehicle (if allowed).

Parameters:

  | type | Type of vehicle

Returns:
  A unused unit number for the given type of vehicle if it is allowed to build one, else `UINT16_MAX`.

Definition at line 1264 of file vehicle.cpp.

References _settings_game, CountCompanyVehicles(), lengthof, VehicleSettings::max_aircraft, VehicleSettings::max_roadveh, VehicleSettings::max_ships, VehicleSettings::max_trains, FreeUnitIDGenerator::NextID(), VEH_AIRCRAFT, VEH_ROAD, VEH_SHIP, VEH_TRAIN, and GameSettings::vehicle.

Referenced by CheckNewTrain(), CmdBuildAircraft(), CmdBuildRailVehicle(), CmdBuildRoadVeh(), CmdBuildShip(), and NormaliseTrainHead().

GetNewVehiclePosResult GetNewVehiclePos | ( | const Vehicle * | v | ) |

Get position information of a vehicle when moving one pixel in the direction it is facing.

Parameters:

  | v | Vehicle to move

Returns:
  Position information after the move

Definition at line 1166 of file vehicle.cpp.

References GetNewVehiclePosResult::new_tile, GetNewVehiclePosResult::old_tile, Vehicle::tile, and GetNewVehiclePosResult::y.

Referenced by AircraftController(), DisasterTick_Aircraft(), DisasterTick_Big_Ufo(), DisasterTick_Big_Ufo_Destroyer(), DisasterTick_Submarine(), DisasterTick_Ufo(), DisasterTick_Zeppeliner(), UpdateAirplanesOnNewStation(), and UpdateOldAircraft().

uint GetVehicleCapacity | ( | const Vehicle * | v,
|  | uint16 * | mail_capacity |
| ) |  |  |

Determines capacity of a given vehicle from scratch.

For aircraft the main capacity is determined. Mail might be present as well.

Note:
  Keep this function consistent with Engine::GetDisplayDefaultCapacity().

Parameters:

  | v | Vehicle of interest
  | mail_capacity | returns secondary cargo (mail) capacity of aircraft

Returns:
  Capacity

Definition at line 1509 of file vehicle.cpp.

References CALLBACK_FAILED, EngineInfo::callback_mask, Engine::CanCarryCargo(), RailVehicleInfo::capacity, Vehicle::cargo_subtype, Vehicle::cargo_type, CBID_VEHICLE_REFIT_CAPACITY, CBM_VEHICLE_REFIT_CAPACITY, CC_PASSENGERS, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_engine_pool >::Get(), Engine::GetDefaultCargoType(), GetVehicleCallback(), HasBit(), IsCargoInClass(), PROP_AIRCRAFT_MAIL_CAPACITY, PROP_AIRCRAFT_PASSENGER_CAPACITY, PROP_ROADVEH_CARGO_CAPACITY, PROP_SHIP_CARGO_CAPACITY, PROP_TRAIN_CARGO_CAPACITY, Engine::type, VEH_AIRCRAFT, VEH_ROAD, VEH_SHIP, and VEH_TRAIN.

Referenced by CmdBuildAircraft(), CmdBuildRoadVeh(), CmdBuildShip(), Train::ConsistChanged(), and RefitVehicle().

SpriteID GetVehiclePalette | ( | const Vehicle * | v | ) |

Get the colour map for a vehicle.

Parameters:

  | v | Vehicle to get colour map for

Returns:
  A ready-to-use palette modifier

Definition at line 1490 of file vehicle.cpp.

References RoadVehicleCache::first_engine, TrainCache::first_engine, SpecializedVehicle< RoadVehicle, VEH_ROAD >::From(), SpecializedVehicle< Train, VEH_TRAIN >::From(), RoadVehicle::rcache, BaseVehicle::type, VEH_ROAD, and VEH_TRAIN.

Referenced by DepotWindow::DepotClick(), DrawAircraftImage(), DrawRoadVehImage(), DrawShipImage(), DrawTrainDetails(), DrawTrainImage(), and VehicleGroupWindow::OnClick().

bool HasVehicleOnPos | ( | TileIndex | tile,
|  | void * | data,
|  | VehicleFromPosProc * | proc |
| ) |  |  |

Checks whether a vehicle in on a specific location.

It will call proc for vehicles until it returns non-NULL.

Note:
  Use FindVehicleOnPos when you have the intention that all vehicles should be iterated over.

Parameters:

  | tile | The location on the map
  | data | Arbitrary data passed to proc
  | proc | The proc that determines whether a vehicle will be "found".

Returns:
  True if proc returned non-NULL.

Definition at line 426 of file vehicle.cpp.

References VehicleFromPos().

Referenced by CheckRoadBlockedForOvertaking(), EnsureNoTrainOnTrack(), ExploreSegment(), HasVehicleOnTunnelBridge(), TrainApproachingCrossing(), and UpdateLevelCrossing().

bool HasVehicleOnPosXY | ( | int | x,
|  | int | y,
|  | void * | data,
|  | VehicleFromPosProc * | proc |
| ) |  |  |

Checks whether a vehicle in on a specific location.

It will call proc for vehicles until it returns non-NULL.

Note:
  Use FindVehicleOnPosXY when you have the intention that all vehicles should be iterated over.

Parameters:

  | x | The X location on the map
  | y | The Y location on the map
  | data | Arbitrary data passed to proc
  | proc | The proc that determines whether a vehicle will be "found".

Returns:
  True if proc returned non-NULL.

Definition at line 367 of file vehicle.cpp.

References VehicleFromPosXY().

bool HasVehicleOnTunnelBridge | ( | TileIndex | tile,
|  | TileIndex | endtile,
|  | const Vehicle * | ignore |
| ) |  |  |

Finds vehicle in tunnel / bridge.

Parameters:

  | tile | first end
  | endtile | second end
  | ignore | Ignore this vehicle when searching

Returns:
  true if the bridge has a vehicle

Definition at line 255 of file vehicle.cpp.

References GetVehicleTunnelBridgeProc(), and HasVehicleOnPos().

Referenced by ClearPathReservation(), CmdBuildRoad(), CmdConvertRail(), and RemoveRoad().

void MarkSingleVehicleDirty | ( | const Vehicle * | v | ) |

Marks viewports dirty where the vehicle's image is In fact, it equals BeginVehicleMove(v); EndVehicleMove(v);.

Parameters:

  | v | vehicle to mark dirty

See also:
  BeginVehicleMove()
  EndVehicleMove()

Definition at line 1157 of file vehicle.cpp.

References MarkAllViewportsDirty().

Referenced by Vehicle::Crash(), InitializeDisasterVehicle(), and Vehicle::~Vehicle().

CommandCost RefitVehicle | ( | Vehicle * | v,
|  | bool | only_this,
|  | CargoID | new_cid,
|  | byte | new_subtype,
|  | DoCommandFlag | flags |
| ) |  |  |

Refits a vehicle (chain).

This is the vehicle-type independent part of the CmdRefitXXX functions.

Parameters:

  | v | The vehicle to refit.
  | only_this | Whether to only refit this vehicle, or the whole chain.
  | new_cid | Cargotype to refit to
  | new_subtype | Cargo subtype to refit to
  | flags | Command flags

Returns:
  refit cost; or CMD_ERROR if no vehicle was actually refitable to the cargo

Definition at line 281 of file vehicle_cmd.cpp.

References Engine::CanCarryCargo(), Vehicle::cargo, Vehicle::cargo_cap, Vehicle::cargo_subtype, Vehicle::cargo_type, DC_EXEC, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_engine_pool >::Get(), Vehicle::GetExpenseType(), GetRefitCost(), GetVehicleCapacity(), HasBit(), Vehicle::InvalidateNewGRFCacheOfChain(), Vehicle::Next(), CargoList< Tinst >::Truncate(), BaseVehicle::type, and VEH_AIRCRAFT.

Referenced by CmdRefitAircraft(), CmdRefitRailVehicle(), CmdRefitRoadVeh(), and CmdRefitShip().

void ReleaseDisastersTargetingVehicle | ( | VehicleID | vehicle | ) |

Notify disasters that we are about to delete a vehicle.

So make them head elsewhere.

Parameters:

  | vehicle | deleted vehicle

Definition at line 948 of file disaster_cmd.cpp.

References Vehicle::current_order, Vehicle::dest_tile, Order::GetDestination(), RandomTile, Order::SetDestination(), and Vehicle::subtype.

Referenced by Vehicle::PreDestructor().

CommandCost SendAllVehiclesToDepot | ( | VehicleType | type,
|  | DoCommandFlag | flags,
|  | bool | service,
|  | Owner | owner,
|  | uint16 | vlw_flag,
|  | uint32 | id |
| ) |  |  |

Send all vehicles of type to depots.

Parameters:

  | type | type of vehicle
  | flags | the flags used for DoCommand()
  | service | should the vehicles only get service in the depots
  | owner | owner of the vehicles to send
  | vlw_flag | tells what kind of list requested the goto depot
  | id | general purpose id whoms meaning is given by `vlw_flag`; e.g. StationID for station lists

Returns:
  0 for success and CMD_ERROR if no vehicle is able to go to depot

Definition at line 585 of file vehicle_cmd.cpp.

References CMD_ERROR, DC_EXEC, DEPOT_DONT_CANCEL, DoCommand(), GenerateVehicleSortList(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, SmallVector< T, S >::Length(), CommandCost::Succeeded(), and Vehicle::tile.

Referenced by CmdSendAircraftToHangar(), CmdSendRoadVehToDepot(), CmdSendShipToDepot(), and CmdSendTrainToDepot().

void ShowNewGrfVehicleError | ( | EngineID | engine,
|  | StringID | part1,
|  | StringID | part2,
|  | GRFBugs | bug_type,
|  | bool | critical |
| ) |  |  |

Displays a "NewGrf Bug" error message for a engine, and pauses the game if not networking.

Parameters:

  | engine | The engine that caused the problem
  | part1 | Part 1 of the error message, taking the grfname as parameter 1
  | part2 | Part 2 of the error message, taking the engine as parameter 2
  | bug_type | Flag to check and set in grfconfig
  | critical | Shall the "OpenTTD might crash"-message be shown when the player tries to unpause?

Definition at line 195 of file vehicle.cpp.

References _networking, CMD_PAUSE, DC_EXEC, DoCommand(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_engine_pool >::Get(), GRFConfig::grf_bugs, HasBit(), lastof, GRFConfig::name, PM_PAUSED_ERROR, PM_PAUSED_NORMAL, SetBit(), SetDParam(), SetDParamStr(), and ShowErrorMessage().

Referenced by CheckConsistencyOfArticulatedVehicle(), RailVehicleLengthChanged(), and Train::UpdateVisualEffect().

void VehicleEnteredDepotThisTick | ( | Vehicle * | v | ) |

Adds a vehicle to the list of vehicles, that visited a depot this tick.

Parameters:

  | *v | vehicle to add

Definition at line 650 of file vehicle.cpp.

References Vehicle::vehstatus.

void VehicleMove | ( | Vehicle * | v,
|  | bool | update_viewport |
| ) |  |  |

Move a vehicle in the game state; that is moving it's position in the position hashes and marking it's location in the viewport dirty if requested.

Parameters:

  | v | vehicle to move
  | update_viewport | whether to dirty the viewport

Definition at line 1122 of file vehicle.cpp.

References Sprite::height, MarkAllViewportsDirty(), max(), min(), RemapCoords(), ST_NORMAL, Sprite::width, Sprite::x_offs, and Sprite::y_offs.

Referenced by AfterLoadVehicles(), CmdBuildAircraft(), CmdBuildRailVehicle(), CmdBuildRailWagon(), CmdBuildRoadVeh(), CmdBuildShip(), DisasterTick_Helicopter_Rotors(), InitializeDisasterVehicle(), and Vehicle::UpdateViewport().

byte VehicleRandomBits | ( |  | ) |

Get a value for a vehicle's random_bits.

Returns:
  A random value from 0 to 255.

Definition at line 276 of file vehicle.cpp.

References GB().

Referenced by CmdBuildAircraft(), CmdBuildRailVehicle(), CmdBuildRailWagon(), CmdBuildRoadVeh(), and CmdBuildShip().